GNU bug report logs - #3347
23.0.93; unnecessary display updates with mouse-drag-region

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: YAMAMOTO Mitsuharu <mituharu@HIDDEN>; dated Fri, 22 May 2009 03:00:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Severity set to 'normal' from 'important' Request was from Chong Yidong <cyd@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'important' from 'serious' Request was from Chong Yidong <cyd@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 3347@HIDDEN:


Received: (at 3347) by emacsbugs.donarmstrong.com; 11 Jun 2009 00:28:17 +0000
From mituharu@HIDDEN Wed Jun 10 17:28:17 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-2.0 required=4.0 tests=AWL autolearn=ham
	version=3.2.5-bugs.debian.org_2005_01_02
Received: from mathmail.math.s.chiba-u.ac.jp (mathmail.math.s.chiba-u.ac.jp [133.82.132.2])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with ESMTP id n5B0SCem013474
	for <3347@HIDDEN>; Wed, 10 Jun 2009 17:28:13 -0700
Received: from church.math.s.chiba-u.ac.jp (church [133.82.132.36])
	by mathmail.math.s.chiba-u.ac.jp (Postfix) with ESMTP id ACB2C2C40;
	Thu, 11 Jun 2009 09:28:10 +0900 (JST)
Date: Thu, 11 Jun 2009 09:28:10 +0900
Message-ID: <wlski7pqat.wl%mituharu@HIDDEN>
From: YAMAMOTO Mitsuharu <mituharu@HIDDEN>
To: Chong Yidong <cyd@HIDDEN>
Cc: 3347 <at> debbugs.gnu.org
Subject: Re: 23.0.93; unnecessary display updates with mouse-drag-region
In-Reply-To: <87d49c6njk.fsf@HIDDEN>
References: <87d49c6njk.fsf@HIDDEN>
User-Agent: Wanderlust/2.14.0 (Africa) SEMI/1.14.6 (Maruoka) FLIM/1.14.8
 (=?ISO-8859-4?Q?Shij=F2?=) APEL/10.6 Emacs/22.3 (sparc-sun-solaris2.8)
 MULE/5.0 (SAKAKI)
Organization: Faculty of Science, Chiba University
MIME-Version: 1.0 (generated by SEMI 1.14.6 - "Maruoka")
Content-Type: text/plain; charset=US-ASCII

>>>>> On Wed, 10 Jun 2009 12:50:23 -0400, Chong Yidong <cyd@HIDDEN> said:

>> Mouse dragging over a text in the default face causes unnecessary
>> updates in other windows displaying the same buffer.
>>
>> I tried some older versions and found that the change below made the
>> difference.
>>
>> 2008-07-08  Chong Yidong  <cyd@HIDDEN>
>>
>>             * xfaces.c (Finternal_merge_in_global_face): Save merged
>>             attributes for the default face back into the face vector.

> I don't see why.  Is Finternal_merge_in_global_face called when you
> perform mouse dragging?  It should not be (and on my current GNU/Linux
> build it isn't).

No.  The breakpoint didn't hit during mouse dragging.

				     YAMAMOTO Mitsuharu
				mituharu@HIDDEN



Acknowledgement sent to YAMAMOTO Mitsuharu <mituharu@HIDDEN>:
Extra info received and forwarded to list. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Information forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3347; Package emacs. Full text available.

Message received at 3347@HIDDEN:


Received: (at 3347) by emacsbugs.donarmstrong.com; 10 Jun 2009 16:50:24 +0000
From cyd@HIDDEN Wed Jun 10 09:50:23 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-1.8 required=4.0 tests=AWL autolearn=ham
	version=3.2.5-bugs.debian.org_2005_01_02
Received: from cyd.mit.edu (CYD.MIT.EDU [18.115.2.24])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with ESMTP id n5AGoKIA010333
	for <3347@HIDDEN>; Wed, 10 Jun 2009 09:50:21 -0700
Received: by cyd.mit.edu (Postfix, from userid 1000)
	id 7173157E269; Wed, 10 Jun 2009 12:50:25 -0400 (EDT)
From: Chong Yidong <cyd@HIDDEN>
To: YAMAMOTO Mitsuharu <mituharu@HIDDEN>
Cc: 3347 <at> debbugs.gnu.org
Subject: Re: 23.0.93; unnecessary display updates with mouse-drag-region
Date: Wed, 10 Jun 2009 12:50:23 -0400
Message-ID: <87d49c6njk.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii

> Mouse dragging over a text in the default face causes unnecessary
> updates in other windows displaying the same buffer.
>
> I tried some older versions and found that the change below made the
> difference.
>
> 2008-07-08  Chong Yidong  <cyd@HIDDEN>
>
>             * xfaces.c (Finternal_merge_in_global_face): Save merged
>             attributes for the default face back into the face vector.

I don't see why.  Is Finternal_merge_in_global_face called when you
perform mouse dragging?  It should not be (and on my current GNU/Linux
build it isn't).



Acknowledgement sent to Chong Yidong <cyd@HIDDEN>:
Extra info received and forwarded to list. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Information forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3347; Package emacs. Full text available.

Message received at 3347@HIDDEN:


Received: (at 3347) by emacsbugs.donarmstrong.com; 23 May 2009 02:00:22 +0000
From mituharu@HIDDEN Fri May 22 19:00:21 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-2.9 required=4.0 tests=AWL,FOURLA,HAS_BUG_NUMBER,
	MONEY,STOCKLIKE autolearn=ham version=3.2.5-bugs.debian.org_2005_01_02
Received: from mathmail.math.s.chiba-u.ac.jp (ntp.math.s.chiba-u.ac.jp [133.82.132.2])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with ESMTP id n4N20FwG001002
	for <3347@HIDDEN>; Fri, 22 May 2009 19:00:16 -0700
Received: from church.math.s.chiba-u.ac.jp (church [133.82.132.36])
	by mathmail.math.s.chiba-u.ac.jp (Postfix) with ESMTP id F39E72C40
	for <3347@HIDDEN>; Sat, 23 May 2009 11:00:13 +0900 (JST)
Date: Sat, 23 May 2009 11:00:13 +0900
Message-ID: <wlzld4efyq.wl%mituharu@HIDDEN>
From: YAMAMOTO Mitsuharu <mituharu@HIDDEN>
To: 3347 <at> debbugs.gnu.org
Subject: Re: bug#3347: 23.0.93;	unnecessary display updates with mouse-drag-region
In-Reply-To: <wl4ovd6e4d.wl%mituharu@HIDDEN>
References: <wl4ovd6e4d.wl%mituharu@HIDDEN>
User-Agent: Wanderlust/2.14.0 (Africa) SEMI/1.14.6 (Maruoka) FLIM/1.14.8
 (=?ISO-8859-4?Q?Shij=F2?=) APEL/10.6 Emacs/22.3 (sparc-sun-solaris2.8)
 MULE/5.0 (SAKAKI)
Organization: Faculty of Science, Chiba University
MIME-Version: 1.0 (generated by SEMI 1.14.6 - "Maruoka")
Content-Type: text/plain; charset=US-ASCII

>>>>> On Fri, 22 May 2009 11:54:58 +0900, YAMAMOTO Mitsuharu <mituharu@HIDDEN> said:

> Mouse dragging over a text in the default face causes unnecessary
> updates in other windows displaying the same buffer.

> Steps to reproduce:

>   1. Invoke "Quartz Debug.app" on Mac OS X and check the "Flash screen
>      updates" button.
>   2. $ emacs -Q -D
>   3. C-x 2
>   4. Drag the mouse over the *scratch* buffer text in the first
>      window.

> Result:

>   The text not only in the first window but also the other one is
>   flashed whereas the latter doesn't need updates.  The flashed area
>   corresponds to the extended/shrunken part of the region in the first
>   window.

> The updates in the second window do not happen if the text is in
> non-default face (e.g., start with "emacs -Q" instead of "emacs -Q
> -D").

> I can't observe this phenomenon on Emacs 22.3.

I tried some older versions and found that the change below made the
difference.

				     YAMAMOTO Mitsuharu
				mituharu@HIDDEN

2008-07-08  Chong Yidong  <cyd@HIDDEN>

	* xfaces.c (Finternal_merge_in_global_face): Save merged
	attributes for the default face back into the face vector.

--- xfaces.c	2008/07/06 03:51:06	1.404
+++ xfaces.c	2008/07/08 17:27:28	1.405
@@ -3966,7 +3966,7 @@
     else if (! UNSPECIFIEDP (gvec[i]))
       lvec[i] = gvec[i];
 
-  /* If the default face was changed, realize it again, and update the
+  /* If the default face was changed, update the face cache and the
      `font' frame parameter.  */
   if (EQ (face, Qdefault))
     {
@@ -3977,9 +3977,12 @@
       /* This can be NULL (e.g., in batch mode).  */
       if (oldface)
 	{
+	  /* Ensure that the face vector is fully specified by merging
+	     the previously-cached vector.  */
 	  bcopy (oldface->lface, attrs, sizeof attrs);
 	  merge_face_vectors (f, lvec, attrs, 0);
-	  newface = realize_face (c, attrs, DEFAULT_FACE_ID);
+	  bcopy (attrs, lvec, sizeof attrs);
+	  newface = realize_face (c, lvec, DEFAULT_FACE_ID);
 
 	  if ((! UNSPECIFIEDP (gvec[LFACE_FAMILY_INDEX])
 	       || ! UNSPECIFIEDP (gvec[LFACE_FOUNDRY_INDEX])



Acknowledgement sent to YAMAMOTO Mitsuharu <mituharu@HIDDEN>:
Extra info received and forwarded to list. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Information forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3347; Package emacs. Full text available.
Severity set to `serious' from `normal' Request was from Stefan Monnier <monnier@HIDDEN> to control@HIDDEN. Full text available.

Message received at submit@HIDDEN:


Received: (at submit) by emacsbugs.donarmstrong.com; 22 May 2009 02:55:15 +0000
From mituharu@HIDDEN Thu May 21 19:55:14 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-1.5 required=4.0 tests=AWL,FOURLA,MONEY,STOCKLIKE
	autolearn=no version=3.2.5-bugs.debian.org_2005_01_02
Received: from fencepost.gnu.org (fencepost.gnu.org [140.186.70.10])
	by rzlab.ucr.edu (8.13.8/8.13.8/Debian-3) with ESMTP id n4M2t9c7008013
	for <submit@HIDDEN>; Thu, 21 May 2009 19:55:10 -0700
Received: from mx10.gnu.org ([199.232.76.166]:35906)
	by fencepost.gnu.org with esmtp (Exim 4.67)
	(envelope-from <mituharu@HIDDEN>)
	id 1M7Kua-0006HO-Dm
	for emacs-pretest-bug@HIDDEN; Thu, 21 May 2009 22:55:08 -0400
Received: from Debian-exim by monty-python.gnu.org with spam-scanned (Exim 4.60)
	(envelope-from <mituharu@HIDDEN>)
	id 1M7KuX-00015d-2M
	for emacs-pretest-bug@HIDDEN; Thu, 21 May 2009 22:55:07 -0400
Received: from ntp.math.s.chiba-u.ac.jp ([133.82.132.2]:65137 helo=mathmail.math.s.chiba-u.ac.jp)
	by monty-python.gnu.org with esmtp (Exim 4.60)
	(envelope-from <mituharu@HIDDEN>)
	id 1M7KuW-000152-8w
	for emacs-pretest-bug@HIDDEN; Thu, 21 May 2009 22:55:04 -0400
Received: from church.math.s.chiba-u.ac.jp (church [133.82.132.36])
	by mathmail.math.s.chiba-u.ac.jp (Postfix) with ESMTP id E29692C44
	for <emacs-pretest-bug@HIDDEN>; Fri, 22 May 2009 11:54:58 +0900 (JST)
Date: Fri, 22 May 2009 11:54:58 +0900
Message-ID: <wl4ovd6e4d.wl%mituharu@HIDDEN>
From: YAMAMOTO Mitsuharu <mituharu@HIDDEN>
To: emacs-pretest-bug@HIDDEN
Subject: 23.0.93; unnecessary display updates with mouse-drag-region
User-Agent: Wanderlust/2.14.0 (Africa) SEMI/1.14.6 (Maruoka) FLIM/1.14.8
 (=?ISO-8859-4?Q?Shij=F2?=) APEL/10.6 Emacs/22.3 (sparc-sun-solaris2.8)
 MULE/5.0 (SAKAKI)
Organization: Faculty of Science, Chiba University
MIME-Version: 1.0 (generated by SEMI 1.14.6 - "Maruoka")
Content-Type: text/plain; charset=US-ASCII
X-detected-operating-system: by monty-python.gnu.org: NetBSD 3.0 (DF)

Mouse dragging over a text in the default face causes unnecessary
updates in other windows displaying the same buffer.

Steps to reproduce:

  1. Invoke "Quartz Debug.app" on Mac OS X and check the "Flash screen
     updates" button.
  2. $ emacs -Q -D
  3. C-x 2
  4. Drag the mouse over the *scratch* buffer text in the first
     window.

Result:

  The text not only in the first window but also the other one is
  flashed whereas the latter doesn't need updates.  The flashed area
  corresponds to the extended/shrunken part of the region in the first
  window.

The updates in the second window do not happen if the text is in
non-default face (e.g., start with "emacs -Q" instead of "emacs -Q
-D").

I can't observe this phenomenon on Emacs 22.3.

				     YAMAMOTO Mitsuharu
				mituharu@HIDDEN

In GNU Emacs 23.0.93.1 (powerpc-apple-darwin9.6.0, X toolkit)
 of 2009-05-22 on yamamoto-mitsuharu-no-power-mac-g5.local
Windowing system distributor `The X.Org Foundation', version 11.0.10402000
configured using `configure  '--without-jpeg' '--without-gif' '--without-tiff''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: ja_JP.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default-enable-multibyte-characters: t

Major mode: Fundamental

Minor modes in effect:
  tooltip-mode: t
  tool-bar-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  blink-cursor-mode: t
  global-auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t




Acknowledgement sent to YAMAMOTO Mitsuharu <mituharu@HIDDEN>:
New bug report received and forwarded. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Report forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3347; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.